using System;
using System.Collections;

namespace jvms.datamodel
{
	[Serializable]
	/// <summary>
	/// Summary description for TypedArrayList.
	/// </summary>
	public class TypedArrayList : ArrayList
	{

		private Type type = null;

		/// <summary>
		/// The constructor for the TypedArrayList
		/// </summary>
		public TypedArrayList( Type type )
		{
			this.type = type;
		}

		public TypedArrayList( TypedArrayList list )
		{
			this.type = list.type;
			foreach( Object o in list )
			{
				this.Add( o );
			}
		}

		/// <summary>
		/// The type of items in this Collection.
		/// </summary>
		public Type ItemType
		{
			get { return type; }
			set { type = value; }
		}

		/// <summary>
		/// Creates an instance of the type of objects in this Collection.
		/// </summary>
		public Object CreateInstanceOfType()
		{
			return type.Assembly.CreateInstance(type.FullName);
		}
	}
}
