using System;
using System.Xml;

using jvms.datamodel.common;
using jvms.datamodel.spd;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	/// <summary>
	/// Summary description for ComponentInstantiation.
	/// </summary>
	public class ComponentInstantiation : XMLObject
	{
		private ComponentProperties properties = new ComponentProperties();
		private String usageName = "";
		private ID id = new ID();

		public ComponentInstantiation()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		/// 
		/// </summary>
		public ID ID
		{
			get
			{
				return id;
			}
			set
			{
				id = value;
			}
		}

		/// <summary>
		/// The properties of the instantiation.
		/// </summary>
		public ComponentProperties Properties
		{
			get
			{
				return properties;
			}
			set
			{
				properties = value;
			}
		}
		/// <summary>
		/// The usage name of the instantiation.
		/// </summary>
		public String UsageName
		{
			get
			{
				return usageName;
			}
			set
			{
				usageName = value;
			}
		}

		/// <summary>
		/// This will convert this object to XML.
		/// </summary>
		/// <param name="document"></param>
		/// <returns></returns>
		public virtual XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "componentinstantiation" );
			element.SetAttribute( "id", id.DCEUUID );
			XMLHelper.writeElement( document, element, "usagename", usageName );

			if( properties.Simples.Count + 
				properties.SimpleSequences.Count +
				properties.Structs.Count +
				properties.StructSequences.Count > 0 )
			{
				element.AppendChild( properties.toXML( document ) );
			}

			return element;
		}
	}
}
