using System;
using System.Xml;

using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	/// <summary>
	/// Summary description for ComponentInstantiationPortConnection.
	/// </summary>
	[Serializable]
	public class ComponentInstantiationSupportInterfacePortConnection : ComponentInstantiationPortConnection
	{

		/// <summary>
		/// This will convert this object to XML.
		/// </summary>
		/// <param name="document"></param>
		/// <returns></returns>
		public override XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "componentsupportedinterface" );
			if( Port != null && Port.RepositoryID != null )
			{
				XMLHelper.writeElement( document, element, "supportedidentifier", Port.RepositoryID.RepositoryID );
			}
			XmlElement instanceRef = document.CreateElement( "componentinstantiationref" );
			element.AppendChild( instanceRef );
			instanceRef.SetAttribute( "refid", Instance.ID.DCEUUID );
			XmlComment comment = document.CreateComment( Instance.UsageName );
			element.AppendChild( comment );
			return element;
		}

	}
}
