using System;
using System.Xml;

using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class DomainFinder : FindBy
	{
		private String name = "";
		private String type = "";

		/// <summary>
		/// The name of the component to find.
		/// </summary>
		public String Name
		{
			get
			{
				return name;
			}

			set
			{
				name = value;
			}
		}

		/// <summary>
		/// The type of the component to find.
		/// </summary>
		public String Type
		{
			get
			{
				return type;
			}

			set
			{
				type = value;
			}
		}

		/// <summary>
		/// This will convert this object to an XML element.
		/// </summary>
		/// <param name="document">The document that this element will go into.</param>
		/// <returns>The element representation of the object.</returns>
		public override XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "domainfinder" );
			element.SetAttribute( "type", type );
			element.SetAttribute( "name", name );
			return element;
		}

		/// <summary>
		/// This will get a string representation of this object.
		/// </summary>
		/// <returns></returns>
		public override String ToString()
		{
			String retval = "<new findby>";
			if( !Name.Equals( "" ) )
			{
				retval = Name + ", type='" + Type + "'";
			}
			return retval;
		}
	}
}
