using System;
using System.Xml;

using jvms.datamodel.spd;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	/// <summary>
	/// Summary description for FindByPortConnection.
	/// </summary>
	[Serializable]
	public class FindByPortConnection : PortConnection
	{
		private FindBy findBy;
		bool usesPort;

		public FindByPortConnection( bool usesPortConnection )
		{
			usesPort = usesPortConnection;
		}

		/// <summary>
		/// 
		/// </summary>
		public FindBy FindBy
		{
			get
			{
				return findBy;
			}
			set
			{
				findBy = value;
			}
		}
		/// <summary>
		/// This will convert this object to XML.
		/// </summary>
		/// <param name="document"></param>
		/// <returns></returns>
		public override XmlElement toXML( XmlDocument document )
		{
			XmlElement element = null;
			if( usesPort )
			{
				element = document.CreateElement( "usesport" );
				if( Port != null && Port.RepositoryID != null )
				{
					XMLHelper.writeElement( document, element, "usesidentifier", Port.UsesName );
				}
			}
			else
			{
				element = document.CreateElement( "providesport" );
				if( Port != null && Port.RepositoryID != null )
				{
					XMLHelper.writeElement( document, element, "providesidentifier", Port.UsesName );
				}
			}
			XmlElement findByElement = document.CreateElement( "findby" );
			element.AppendChild( findByElement );

			findByElement.AppendChild( findBy.toXML( document ) );			
			return element;
		}

	}
}
