using System;

namespace jvms.datamodel.common
{
	[Serializable]
	public class ID
	{
		private String dceUUID = "DCE:" + Guid.NewGuid().ToString().ToUpper();

		/// <summary>
		/// This is the id used to reference this component.
		/// </summary>
		public String DCEUUID
		{
			get
			{
				return dceUUID;
			}

			set
			{
				dceUUID = value;
			}
		}

		/// <summary>
		/// This will return a string representation of this class.
		/// </summary>
		/// <returns>This class represented in a human readable form.</returns>
		public override String ToString()
		{
			String retval = "<New ID>";
			if( !dceUUID.Equals( "" ) )
			{
				retval = DCEUUID;
			}
			return retval;
		}
	}
}