using System;
using System.Xml;

using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class NamingService : FindBy
	{
		private String name = "";

		/// <summary>
		/// This is the name to lookup in the naming service.
		/// </summary>
		public String Name
		{
			get
			{
				return name;
			}
			set
			{
				name = value;
			}
		}

		/// <summary>
		/// This will convert this object to an XML element.
		/// </summary>
		/// <param name="document">The document that this element will go into.</param>
		/// <returns>The element representation of the object.</returns>
		public override XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "namingservice" );
			element.SetAttribute( "name", name );
			return element;
		}

		/// <summary>
		/// This will get a string representation of this object.
		/// </summary>
		/// <returns></returns>
		public override String ToString()
		{
			String retval = "<new findby>";
			if( !Name.Equals( "" ) )
			{
				retval = Name;
			}
			return retval;
		}
	}
}
