using System;
using System.Xml;

using jvms.datamodel.prf;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class SimpleRef : XMLObject
	{
		private String simpleValue = "";
		private Simple simple;

		/// <summary>
		/// The value of the simple ref.
		/// </summary>
		public String Value
		{
			get
			{
				return simpleValue;
			}
			set
			{
				simpleValue = value;
			}
		}
		/// <summary>
		/// The id of the simple property that is being referenced.
		/// </summary>
		public Simple Simple
		{
			get
			{
				return simple;
			}
			set
			{
				simple = value;
			}
		}

		/// <summary>
		/// This will return a string representation of this class.
		/// </summary>
		/// <returns>This class represented in a human readable form.</returns>
		public override String ToString()
		{
			String retval = "<New Simple Ref>";
			if( simple != null )
			{
				retval = simple.Name + " Reference";
			}
			return retval;
		}

		/// <summary>
		/// This will convert this object to an XML element.
		/// </summary>
		/// <param name="document">The document that this element will go into.</param>
		/// <returns>The element representation of the object.</returns>
		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "simpleref" );
			element.SetAttribute( "refid", simple.ID.DCEUUID );
			element.SetAttribute( "value", simpleValue );

			return element;
		}
	}
}
