using System;
using System.Xml;

using jvms.datamodel.prf;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class SimpleRefReadOnly
	{
		private SimpleRef simpleRef = null;

		public SimpleRefReadOnly( SimpleRef sRef )
		{
			simpleRef = sRef;
		}

		/// <summary>
		/// The value of the simple ref.
		/// </summary>
		public String Value
		{
			get
			{
				return simpleRef.Value;
			}
			set
			{
				simpleRef.Value = value;
			}
		}
		/// <summary>
		/// The id of the simple property that is being referenced.
		/// </summary>
		public Simple Simple
		{
			get
			{
				return simpleRef.Simple;
			}
		}

		/// <summary>
		/// This will return a string representation of this class.
		/// </summary>
		/// <returns>This class represented in a human readable form.</returns>
		/*public override String ToString()
		{
			String retval = "<New Simple Ref>";
			if( simple != null )
			{
				retval = simple.Name + " Reference";
			}
			return retval;
		}*/
	}
}
