using System;
using System.Collections;
using System.Collections.Specialized;
using System.Xml;

using jvms.datamodel.prf;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class SimpleSequenceRef : XMLObject
	{
		private SimpleSequence simpleSequence;
		private IList values = new ArrayList();

		public SimpleSequence SimpleSequence
		{
			get
			{
				return simpleSequence;
			}
			set
			{
				simpleSequence = value;
			}
		}

		public IList Values
		{
			get
			{
				return values;
			}
			set
			{
				values = value;
			}
		}

		/// <summary>
		/// This will convert this object to an XML element.
		/// </summary>
		/// <param name="document">The document that this element will go into.</param>
		/// <returns>The element representation of the object.</returns>
		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "simplesequenceref" );
			element.SetAttribute( "refid", simpleSequence.ID.DCEUUID );
			XmlElement valuesElement = document.CreateElement( "values" );
			element.AppendChild( valuesElement );
			XMLHelper.writeListOfStringElements( document, valuesElement, "value", values );

			return element;
		}
	}
}
