using System;
using System.Collections;
using System.Xml;

using jvms.datamodel.prf;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class StructRef : XMLObject
	{
// 		public SimpleRef theSimpleRef;
		private TypedArrayList simpleRefs = new TypedArrayList(typeof(SimpleRef));
		private Struct structRef;

		/// <summary>
		/// The simple refs.
		/// </summary>
		public TypedArrayList SimpleRefs
		{
			get
			{
				return simpleRefs;
			}

			set
			{
				simpleRefs = value;
			}
		}

		public Struct Struct
		{
			get
			{
				return structRef;
			}

			set
			{
				structRef = value;
			}
		}

		/// <summary>
		/// This will convert this object to an XML element.
		/// </summary>
		/// <param name="document">The document that this element will go into.</param>
		/// <returns>The element representation of the object.</returns>
		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "structref" );
			element.SetAttribute( "refid", structRef.ID.DCEUUID );
			XMLHelper.writeListOfXMLElements( document, element, simpleRefs );

			return element;
		}
	}
}
