using System;
using System.Collections;
using System.Xml;

using jvms.datamodel.prf;
using jvms.xmlgeneration;

namespace jvms.datamodel.common
{
	[Serializable]
	public class StructSequenceRef :  XMLObject
	{
		private TypedArrayList structValues = new TypedArrayList(typeof(SimpleRef));	
		private StructSequence structSequence;

		/// <summary>
		/// The list of structure values.
		/// </summary>
		public TypedArrayList StructValues
		{
			get
			{
				return structValues;
			}

			set
			{
				structValues = value;
			}
		}

		/// <summary>
		/// The ref id.
		/// </summary>
		public StructSequence StructSequence
		{
			get
			{
				return structSequence;
			}

			set
			{
				structSequence = value;
			}
		}

		/// <summary>
		/// This will convert this object to an XML element.
		/// </summary>
		/// <param name="document">The document that this element will go into.</param>
		/// <returns>The element representation of the object.</returns>
		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "structsequenceref" );
			element.SetAttribute( "refid", structSequence.ID.DCEUUID );
			XmlElement structvalue = document.CreateElement( "structvalue" );
			element.AppendChild( element );
			XMLHelper.writeListOfXMLElements( document, element, structValues );

			return element;
		}
	}
}
