using System;
using System.Xml;

using jvms.xmlgeneration;

namespace jvms.datamodel.dcd
{
	[Serializable]
	/// <summary>
	/// "The optional filesystemnames element indicates the mounted file system names for CF DeviceManagers FileManager."
	/// </summary>
	public class FileSystemName : XMLObject
	{
		private String deviceID = "";
		private String mountName = "";

		/// <summary>
		/// This is the device ID.
		/// </summary>
		public String DeviceID
		{
			get
			{
				return deviceID;
			}
			set
			{
				deviceID = value;
			}
		}

		/// <summary>
		/// The is the mount name.
		/// </summary>
		public String MountName
		{
			get
			{
				return mountName;
			}

			set
			{
				mountName = value;
			}
		}

		/// <summary>
		/// This will return a string representation of the Author class.
		/// </summary>
		/// <returns>This author represented in a human readable form.</returns>
		public override String ToString()
		{
			String retval = "<New FileSystemName>";
			if( !MountName.Equals( "" ) )
			{
				retval = MountName;
			}
			return retval;
		}

		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "filesystemname" );
			element.SetAttribute( "mountname", mountName );
			element.SetAttribute( "deviceid", deviceID );
			return element;
		}
	}
}
