using System;
using System.Xml;

using jvms.datamodel.common;
using jvms.xmlgeneration;

namespace jvms.datamodel.prf
{
	[Serializable]
	/// <summary>
	/// Summary description for StructValue.
	/// </summary>
	public class StructValue : XMLObject
	{
		private TypedArrayList simpleRefs  = new TypedArrayList(typeof(SimpleRef));

		public StructValue()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		public StructValue( StructValue other )
		{
			SimpleRef simpleRef = null;
			foreach( SimpleRef sr in other.SimpleRefs )
			{
				simpleRef = new SimpleRef();
				simpleRef.Simple = sr.Simple;  //don't think this needs to be copied
 				simpleRef.Value = sr.Value;
				simpleRefs.Add( simpleRef );
			}
		}

		/// <summary>
		/// This is the list of simple refs
		/// </summary>
		public TypedArrayList SimpleRefs
		{
			get
			{
				return simpleRefs;
			}
			set
			{
				simpleRefs = value;
			}
		}

		/// <summary>
		/// This will return a string representation of the StructValue class.
		/// </summary>
		/// <returns>This author represented in a human readable form.</returns>
		public override String ToString()
		{
			return "Struct Value";
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="document"></param>
		/// <returns></returns>
		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "structvalue" );
			XMLHelper.writeListOfXMLElements( document, element, simpleRefs );

			return element;
		}
	}
}
