using System;
using System.Xml;

using jvms.datamodel.common;
using jvms.xmlgeneration;

namespace jvms.datamodel.sad
{
	[Serializable]
	/// <summary>
	/// 
	/// </summary>
	public class FindComponent : XMLObject
	{
		private NamingService namingService = null;
		private ComponentResourceFactoryRef resourceFactory = null;

		/// <summary>
		/// The naming service.
		/// </summary>
		public NamingService NamingService
		{
			get
			{
				return namingService;
			}
			set
			{
				namingService = value;
			}
		}

		/// <summary>
		/// The resource factory.
		/// </summary>
		public ComponentResourceFactoryRef ResourceFactory
		{
			get
			{
				return resourceFactory;
			}
			set
			{
				resourceFactory = value;
			}
		}

		public override String ToString()
		{
			String retval = "";
			if( namingService != null &&
				!"".Equals( namingService.Name ) )
			{
				retval = namingService.Name;
			}
			else if( resourceFactory != null &&
				resourceFactory.Instance != null )
			{
				retval = resourceFactory.Instance.UsageName;
			}
			return retval;
		}

		/// <summary>
		/// This will convert this object to SCA xml.
		/// </summary>
		/// <param name="document"></param>
		/// <returns></returns>
		public XmlElement toXML( XmlDocument document )
		{
			XmlElement element = document.CreateElement( "findcomponent" );
			if( namingService != null && !namingService.Name.Equals( "" ) )
			{
				element.AppendChild( namingService.toXML( document ) );
			}
			else if( resourceFactory != null &&
				     resourceFactory.Instance != null )
			{
				element.AppendChild( resourceFactory.toXML( document ) );
			}
			else
			{
				element = null;
			}

			return element;
		}
	}
}
