using System;

namespace jvms.datamodel.spd
{
	[Serializable]
	public class NameVersion
	{
		private String version = "";
		private String name = "";

		/// <summary>
		/// The version in the NV pair.
		/// </summary>
		public String Version
		{
			get
			{
				return version;
			}
			set
			{
				version = value;
			}
		}
		/// <summary>
		/// The name in the NV pair.
		/// </summary>
		public String Name
		{
			get
			{
				return name;
			}
			set
			{
				name = value;
			}
		}

		/// <summary>
		/// This will return a string representation of this class.
		/// </summary>
		/// <returns>This class represented in a human readable form.</returns>
		public override String ToString()
		{
			String retval = "<New NameVersion>";
			if( !Name.Equals( "" ) )
			{
				retval = Name;
			}
			return retval;
		}
	}

	[Serializable]
	public class OSNameVersion : NameVersion
	{
	}
}
