using System;

using jvms.datamodel.scd;

namespace jvms.datamodel.spd
{
	[Serializable]
	public class SCAComponent : NonSCAComponent
	{
		/// <summary>
		/// The descriptor element points to the local filename of the Software Component Descriptor (SCD) file used to document the interface information for the component being delivered to the system.  In the case of an SCA Component, the SCD will contain information about three aspects of the component (the component type, message ports, and IDL interfaces).  The SCD file is optional, since some SCA components are non-CORBA components, like digital signal processor (DSP) "c" code (see section on software component descriptor file, section D.5 ).
		/// </summary>
		private SoftwareComponent descriptor = null;

		/// <summary>
		/// Constructor.
		/// </summary>
		public SCAComponent()
		{
			descriptor = new SoftwareComponent( this );
		}

		public SoftwareComponent Descriptor
		{
			get { return descriptor; }
			set { descriptor = value; }
		}
	}
}
