using System;
using System.Collections;
using System.IO;
using System.Xml;

namespace jvms.xmlgeneration
{
	[Serializable]
	/// <summary>
	/// Summary description for FileSystemObject.
	/// </summary>
	public abstract class FileSystemObject : XMLObject
	{
		private DirectoryInfo directory = new DirectoryInfo( "\\" );

		public abstract XmlElement toXML( XmlDocument document );

		/// <summary>
		/// This will get the relative name of the file to write to.  This
		/// string shall begin with a \
		/// </summary>
		/// <returns>The path to write this file to.</returns>
		public abstract String getFilename();

		public String getFullFilename()
		{
			return directory.ToString() + getFilename();
		}

		/// <summary>
		/// The directory to save this file name to
		/// </summary>
		public DirectoryInfo Directory
		{
			get
			{
				return directory;
			}
			set
			{
				directory = value;
			}
		}
	}
}
