using System;
using System.IO;
using System.Xml;

using jvms.datamodel;

namespace jvms.xmlgeneration
{
	/// <summary>
	/// Summary description for XMLWriter.
	/// </summary>
	public class XMLWriter
	{
		public XMLWriter()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		/// This will write an object as xml to the filesystem.
		/// </summary>
		/// <param name="xmlObject">The object to write as XML</param>
		/// <param name="project">The project which describes the location to write to.</param>
		public void writeObject( FileSystemObject xmlObject, Project project )
		{
			XmlDocument document = new XmlDocument();
			XmlElement rootElement = xmlObject.toXML( document );
			document.AppendChild( rootElement );
			String path = project.ProjectDirectory + xmlObject.getFullFilename();
			String pathDirectory = Path.GetDirectoryName( path );
			if( Directory.Exists( pathDirectory ) )
			{
				document.Save( path );
			}
			else
			{
				throw new Exception( "The XML output directory does not exist:" + path );
			}
		}
	}
}
