using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;

namespace jvms.presentation
{
	/// <summary>
	/// Summary description for AboutForm.
	/// </summary>
	public class AboutForm : System.Windows.Forms.Form
	{
		#region Windows Form Designer generated state
		private System.Windows.Forms.Label titleLabel;
		private System.Windows.Forms.Label byLabel;
		private System.Windows.Forms.GroupBox separator;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Label versionLabel;
		private System.Windows.Forms.LinkLabel linkLabel;
		private System.Windows.Forms.Label visitLabel;
		private System.Windows.Forms.Label restLabel;
		private System.Windows.Forms.PictureBox logoPictureBox;
		#endregion

		/// <summary>
		/// Creates a new AboutForm.
		/// </summary>
		public AboutForm()
		{
			InitializeComponent();

			linkLabel.Links.Add( 0, linkLabel.Text.Length, "http://jtrs.kelut.org" );
			linkLabel.LinkClicked += new LinkLabelLinkClickedEventHandler( linkClicked );
			okButton.Click += new EventHandler( okButtonClicked );

			Assembly jvmsAssembly = Assembly.GetExecutingAssembly();
			versionLabel.Text = "Version: " + jvmsAssembly.GetName().Version.ToString();
		}

		/// <summary>
		/// Called when a link has been clicked.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void linkClicked( Object source, LinkLabelLinkClickedEventArgs e )
		{
			try
			{
				System.Diagnostics.Process.Start( e.Link.LinkData.ToString() );
			}
			catch ( Exception )
			{
				// Do nothing
			}
		}

		/// <summary>
		/// Called when the ok button has been clicked.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void okButtonClicked( Object source, EventArgs e )
		{
			Close();
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutForm));
			this.titleLabel = new System.Windows.Forms.Label();
			this.byLabel = new System.Windows.Forms.Label();
			this.versionLabel = new System.Windows.Forms.Label();
			this.separator = new System.Windows.Forms.GroupBox();
			this.okButton = new System.Windows.Forms.Button();
			this.logoPictureBox = new System.Windows.Forms.PictureBox();
			this.visitLabel = new System.Windows.Forms.Label();
			this.linkLabel = new System.Windows.Forms.LinkLabel();
			this.restLabel = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// titleLabel
			// 
			this.titleLabel.Font = new System.Drawing.Font("Arial", 12F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.titleLabel.Location = new System.Drawing.Point(72, 16);
			this.titleLabel.Name = "titleLabel";
			this.titleLabel.Size = new System.Drawing.Size(240, 24);
			this.titleLabel.TabIndex = 0;
			this.titleLabel.Text = "JTRS Visual Modeling Studio";
			// 
			// byLabel
			// 
			this.byLabel.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.byLabel.Location = new System.Drawing.Point(72, 40);
			this.byLabel.Name = "byLabel";
			this.byLabel.Size = new System.Drawing.Size(136, 16);
			this.byLabel.TabIndex = 1;
			this.byLabel.Text = "By The A-Team - 2003";
			// 
			// versionLabel
			// 
			this.versionLabel.Location = new System.Drawing.Point(72, 64);
			this.versionLabel.Name = "versionLabel";
			this.versionLabel.Size = new System.Drawing.Size(240, 16);
			this.versionLabel.TabIndex = 10;
			this.versionLabel.Text = "Version";
			// 
			// separator
			// 
			this.separator.Location = new System.Drawing.Point(8, 120);
			this.separator.Name = "separator";
			this.separator.Size = new System.Drawing.Size(344, 8);
			this.separator.TabIndex = 11;
			this.separator.TabStop = false;
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(288, 136);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(64, 23);
			this.okButton.TabIndex = 12;
			this.okButton.Text = "OK";
			// 
			// logoPictureBox
			// 
			this.logoPictureBox.Image = ((System.Drawing.Bitmap)(resources.GetObject("logoPictureBox.Image")));
			this.logoPictureBox.Location = new System.Drawing.Point(16, 16);
			this.logoPictureBox.Name = "logoPictureBox";
			this.logoPictureBox.Size = new System.Drawing.Size(32, 32);
			this.logoPictureBox.TabIndex = 13;
			this.logoPictureBox.TabStop = false;
			// 
			// visitLabel
			// 
			this.visitLabel.Location = new System.Drawing.Point(72, 96);
			this.visitLabel.Name = "visitLabel";
			this.visitLabel.Size = new System.Drawing.Size(32, 16);
			this.visitLabel.TabIndex = 14;
			this.visitLabel.Text = "Visit";
			// 
			// linkLabel
			// 
			this.linkLabel.Cursor = System.Windows.Forms.Cursors.Hand;
			this.linkLabel.Location = new System.Drawing.Point(96, 96);
			this.linkLabel.Name = "linkLabel";
			this.linkLabel.Size = new System.Drawing.Size(72, 16);
			this.linkLabel.TabIndex = 15;
			this.linkLabel.TabStop = true;
			this.linkLabel.Text = "jtrs.kelut.org";
			// 
			// restLabel
			// 
			this.restLabel.Location = new System.Drawing.Point(160, 96);
			this.restLabel.Name = "restLabel";
			this.restLabel.Size = new System.Drawing.Size(112, 16);
			this.restLabel.TabIndex = 16;
			this.restLabel.Text = "for more information.";
			// 
			// AboutForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(362, 170);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.restLabel,
																		  this.linkLabel,
																		  this.visitLabel,
																		  this.logoPictureBox,
																		  this.okButton,
																		  this.separator,
																		  this.versionLabel,
																		  this.byLabel,
																		  this.titleLabel});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AboutForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "About JVMS";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
