using System;
using System.Collections;

using jvms.validation;

namespace jvms.presentation
{
	/// <summary>
	/// Represents a collection of dynamic attributes.
	/// </summary>
	public class AttributeSheet : BoundPropertyBag
	{
		private Object workingObject;
		private IList attributeTypes;

		/// <summary>
		/// This will get the object that is being edited by this attribute sheet.
		/// </summary>
		public Object WorkingObject
		{
			get{ return workingObject; }
			set{ workingObject = value; }
		}

		/// <summary>Gets or sets the list of attribute types.</summary>
		/// <value>The list of attribute types.</value>
		public IList AttributeTypes
		{
			get { return attributeTypes; }
			set { attributeTypes = value; }
		}

		/// <summary>
		/// Creates a new AttributeSheet.
		/// </summary>
		/// <param name="attributeTypes">A list of attribute types.</param>
		public AttributeSheet( IList attributeTypes )
		{
			this.attributeTypes = attributeTypes;
			foreach( AttributeType attr in attributeTypes )
			{
				Properties.Add( attr.BoundSpec );
			}
		}
	}
}
