using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Reflection;
using System.Threading;
using System.Windows.Forms;

using jvms.system;

namespace jvms.presentation
{
	/// <summary>
	/// Summary description for CreditsForm.
	/// </summary>
	public class CreditsForm : System.Windows.Forms.Form
	{
		#region Windows Form Designer generated state

		private System.Windows.Forms.GroupBox separator;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Panel maskPanel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion

		private Panel creditsPanel;
		private bool stop = false;

		/// <summary>
		/// Creates a new CreditsForm.
		/// </summary>
		public CreditsForm()
		{
			InitializeComponent();
			initCreditsPanel();

			Load += new EventHandler( creditsFormLoaded );
			Closing += new CancelEventHandler( formClosing );
			okButton.Click += new EventHandler( okButtonClicked );
		}

		/// <summary>
		/// Initializes the credits panel.
		/// </summary>
		private void initCreditsPanel()
		{
			creditsPanel = new Panel();

			Font titleFont = new Font( "Arial", 10.0f, FontStyle.Bold | FontStyle.Underline );
			Font textFont = new Font( "Arial", 9.0f );
			Font textUnderlineFont = new Font( "Arial", 9.0f, FontStyle.Underline );
			Font smallTextFont = new Font( "Arial", 8.0f );

			Label titleLabel = new Label();
			titleLabel.Text = "JTRS Visual Modeling Studio";
			titleLabel.Font = titleFont;
			titleLabel.Size = new Size( 250, 20 );
			titleLabel.Location = new Point( 3, 5 );

			Label authorsLabel = new Label();
			authorsLabel.Text = "By The A-Team:";
			authorsLabel.Font = textFont;
			authorsLabel.Size = new Size( 150, 20 );
			authorsLabel.Location = new Point( titleLabel.Left, titleLabel.Bottom );
			
			Label garrettLabel = new Label();
			garrettLabel.Text = "Garrett Wampole (garrett@csh.rit.edu)";
			garrettLabel.Font = smallTextFont;
			garrettLabel.Size = new Size( 250, 20 );
			garrettLabel.Location = new Point( authorsLabel.Left, authorsLabel.Bottom + 3 );

			Label benLabel = new Label();
			benLabel.Text = "Ben Litchfield (ben@csh.rit.edu)";
			benLabel.Font = smallTextFont;
			benLabel.Size = new Size( 200, 20 );
			benLabel.Location = new Point( garrettLabel.Left, garrettLabel.Bottom );

			Label jasonOLabel = new Label();
			jasonOLabel.Text = "Jason Offord (jasonoff@csh.rit.edu)";
			jasonOLabel.Font = smallTextFont;
			jasonOLabel.Size = new Size( 200, 20 );
			jasonOLabel.Location = new Point( benLabel.Left, benLabel.Bottom );

			Label jasonGLabel = new Label();
			jasonGLabel.Text = "Jason Gilman (jrg0839@rit.edu)";
			jasonGLabel.Font = smallTextFont;
			jasonGLabel.Size = new Size( 200, 20 );
			jasonGLabel.Location = new Point( jasonOLabel.Left, jasonOLabel.Bottom );

			Label daveLabel = new Label();
			daveLabel.Text = "David Bryant (djb9751@rit.edu)";
			daveLabel.Font = smallTextFont;
			daveLabel.Size = new Size( 200, 20 );
			daveLabel.Location = new Point( jasonGLabel.Left, jasonGLabel.Bottom );

			Label thanksLabel = new Label();
			thanksLabel.Text = "The A-Team would like to extend special thanks to the following people:";
			thanksLabel.Font = textFont;
			thanksLabel.Size = new Size( maskPanel.Width - 10, 40 );
			thanksLabel.Location = new Point( daveLabel.Left, daveLabel.Bottom + 50 );

			Label chuckLabel = new Label();
			chuckLabel.Text = "Mr. Charles Linn";
			chuckLabel.Font = textUnderlineFont;
			chuckLabel.Size = new Size( 200, 20 );
			chuckLabel.Location = new Point( thanksLabel.Left, thanksLabel.Bottom );

			Label chuckExpLabel = new Label();
			chuckExpLabel.Text = "For lending us his considerable knowledge of the SCA, his valuable time and knowledge, and his patience.  Thanks Chuck!";
			chuckExpLabel.Font = smallTextFont;
			chuckExpLabel.Size = new Size( maskPanel.Width - 10, 40 );
			chuckExpLabel.Location = new Point( chuckLabel.Left, chuckLabel.Bottom );

			Label jimLabel = new Label();
			jimLabel.Text = "Dr. Jim Vallino";
			jimLabel.Font = textUnderlineFont;
			jimLabel.Size = new Size( 200, 20 );
			jimLabel.Location = new Point( chuckExpLabel.Left, chuckExpLabel.Bottom );

			Label jimExpLabel = new Label();
			jimExpLabel.Text = "For providing guidence and insight throughout the process.";
			jimExpLabel.Font = smallTextFont;
			jimExpLabel.Size = new Size( maskPanel.Width - 10, 20 );
			jimExpLabel.Location = new Point( jimLabel.Left, jimLabel.Bottom );

			Label stephLabel = new Label();
			stephLabel.Text = "Prof. Stephanie Ludi";
			stephLabel.Font = textUnderlineFont;
			stephLabel.Size = new Size( 200, 20 );
			stephLabel.Location = new Point( jimExpLabel.Left, jimExpLabel.Bottom );

			Label stephExpLabel = new Label();
			stephExpLabel.Text = "For showing us how important requirements really are!";
			stephExpLabel.Font = smallTextFont;
			stephExpLabel.Size = new Size( maskPanel.Width - 10, 20 );
			stephExpLabel.Location = new Point( stephLabel.Left, stephLabel.Bottom );

			Label jLabel = new Label();
			jLabel.Text = "Jason Martin";
			jLabel.Font = textUnderlineFont;
			jLabel.Size = new Size( 200, 20 );
			jLabel.Location = new Point( stephExpLabel.Left, stephExpLabel.Bottom );

			Label jExpLabel = new Label();
			jExpLabel.Text = "For creating the excellent JVMS logo on short notice.  Visit Jason's design site at http://www.tranq.com/.";
			jExpLabel.Font = smallTextFont;
			jExpLabel.Size = new Size( maskPanel.Width - 10, 40 );
			jExpLabel.Location = new Point( jLabel.Left, jLabel.Bottom );

			Label seLabel = new Label();
			seLabel.Text = "The Software Engineering Department at RIT";
			seLabel.Font = textUnderlineFont;
			seLabel.Size = new Size( 300, 20 );
			seLabel.Location = new Point( jExpLabel.Left, jExpLabel.Bottom );

			Label seExpLabel = new Label();
			seExpLabel.Text = "For being an absolutely wonderful group of people, and being directly responsible for making all of our tenures at RIT rewarding and enjoyable.";
			seExpLabel.Font = smallTextFont;
			seExpLabel.Size = new Size( maskPanel.Width - 10, 50 );
			seExpLabel.Location = new Point( seLabel.Left, seLabel.Bottom );

			Label messageLabel = new Label();
			messageLabel.Text = "A message from the A-Team:  Thanks for using JVMS!  We hope you have as much fun using it as we had creating it.";
			messageLabel.Font = textFont;
			messageLabel.Size = new Size( maskPanel.Width - 10, 45 );
			messageLabel.Location = new Point( seExpLabel.Left, seExpLabel.Bottom + 20 );

			Label quotesLabel = new Label();
			quotesLabel.Text = "And now...some quotes";
			quotesLabel.Font = textUnderlineFont;
			quotesLabel.Size = new Size( 250, 20 );
			quotesLabel.Location = new Point( messageLabel.Left, messageLabel.Bottom + 600 );

			Label quote1Label = new Label();
			quote1Label.Text = "That's what Phase 3 is for. - Ben";
			quote1Label.Font = smallTextFont;
			quote1Label.Size = new Size( 300, 20 );
			quote1Label.Location = new Point( quotesLabel.Left, quotesLabel.Bottom + 50 );

			Label quote2Label = new Label();
			quote2Label.Text = "We don't support that. - Garrett";
			quote2Label.Font = smallTextFont;
			quote2Label.Size = new Size( 300, 20 );
			quote2Label.Location = new Point( quote1Label.Left, quote1Label.Bottom + 40 );

			Label quote3Label = new Label();
			quote3Label.Text = "Ah, the dreaded devicethatloadedthiscomponentref. - Ben";
			quote3Label.Font = smallTextFont;
			quote3Label.Size = new Size( 300, 20 );
			quote3Label.Location = new Point( quote2Label.Left, quote2Label.Bottom + 40 );

			Label quote4Label = new Label();
			quote4Label.Text = "This isn't your grandfather's radio. - Garrett";
			quote4Label.Font = smallTextFont;
			quote4Label.Size = new Size( 300, 20 );
			quote4Label.Location = new Point( quote3Label.Left, quote3Label.Bottom + 40 );

			Label quote5Label = new Label();
			quote5Label.Text = "That's right, two bugs per thousand lines of code. - Jason O.";
			quote5Label.Font = smallTextFont;
			quote5Label.Size = new Size( 300, 20 );
			quote5Label.Location = new Point( quote4Label.Left, quote4Label.Bottom + 40 );

			Label quote6Label = new Label();
			quote6Label.Text = "I had to go to the vet with my roommate's cat. - Jason G.";
			quote6Label.Font = smallTextFont;
			quote6Label.Size = new Size( 300, 20 );
			quote6Label.Location = new Point( quote5Label.Left, quote5Label.Bottom + 40 );

			Label quote7Label = new Label();
			quote7Label.Text = "This is going to be ugly. - Ben";
			quote7Label.Font = smallTextFont;
			quote7Label.Size = new Size( 300, 20 );
			quote7Label.Location = new Point( quote6Label.Left, quote6Label.Bottom + 40 );

			Label quote8Label = new Label();
			quote8Label.Text = "Double-clicking 'property' relationship crashes program. - Jason O.";
			quote8Label.Font = smallTextFont;
			quote8Label.Size = new Size( 300, 40 );
			quote8Label.Location = new Point( quote7Label.Left, quote7Label.Bottom + 30 );

			Label quote9Label = new Label();
			quote9Label.Text = "DeviceConfigurationComponentInstantiationDrawableComponent?  That's quite the class name. - Garrett";
			quote9Label.Font = smallTextFont;
			quote9Label.Size = new Size( 300, 40 );
			quote9Label.Location = new Point( quote8Label.Left, quote8Label.Bottom + 30 );

			Label quote10Label = new Label();
			quote10Label.Text = "I don't have jumper cables, my roommate took them. - David";
			quote10Label.Font = smallTextFont;
			quote10Label.Size = new Size( 300, 20 );
			quote10Label.Location = new Point( quote9Label.Left, quote9Label.Bottom + 40 );

			Label quote11Label = new Label();
			quote11Label.Text = "How about an EasterEggProvider object? - Ben";
			quote11Label.Font = smallTextFont;
			quote11Label.Size = new Size( 300, 20 );
			quote11Label.Location = new Point( quote10Label.Left, quote10Label.Bottom + 40 );

			Label quote12Label = new Label();
			quote12Label.Text = "We get an A, right? - Garrett";
			quote12Label.Font = smallTextFont;
			quote12Label.Size = new Size( 300, 20 );
			quote12Label.Location = new Point( quote11Label.Left, quote11Label.Bottom + 40 );

			Label teaserLabel1 = new Label();
			teaserLabel1.Text = "Thanks for using JVMS...";
			teaserLabel1.Font = textFont;
			teaserLabel1.Size = new Size( 300, 20 );
			teaserLabel1.Location = new Point( quote11Label.Left, quote11Label.Bottom + 500 );

			Label teaserLabel2 = new Label();
			teaserLabel2.Text = "Hope it helps you create Domain Profiles.";
			teaserLabel2.Font = textFont;
			teaserLabel2.Size = new Size( 300, 20 );
			teaserLabel2.Location = new Point( teaserLabel1.Left, teaserLabel1.Bottom + 250 );

			Label teaserLabel3 = new Label();
			teaserLabel3.Text = "And understand the SCA a little better.";
			teaserLabel3.Font = textFont;
			teaserLabel3.Size = new Size( 300, 20 );
			teaserLabel3.Location = new Point( teaserLabel2.Left, teaserLabel2.Bottom + 100 );

			Label teaserLabel4 = new Label();
			teaserLabel4.Text = "If that's even possible.";
			teaserLabel4.Font = textFont;
			teaserLabel4.Size = new Size( 300, 20 );
			teaserLabel4.Location = new Point( teaserLabel3.Left, teaserLabel3.Bottom + 400 );

			Label teaserLabel5 = new Label();
			teaserLabel5.Text = "OK that's it, there are no more credits...";
			teaserLabel5.Font = textFont;
			teaserLabel5.Size = new Size( 300, 20 );
			teaserLabel5.Location = new Point( teaserLabel4.Left, teaserLabel4.Bottom + 500 );

			Label teaserLabel6 = new Label();
			teaserLabel6.Text = "No really, I'm not kidding, that's all...";
			teaserLabel6.Font = textFont;
			teaserLabel6.Size = new Size( 300, 20 );
			teaserLabel6.Location = new Point( teaserLabel5.Left, teaserLabel5.Bottom + 350 );

			Label teaserLabel7 = new Label();
			teaserLabel7.Text = "Still here, huh?  Don't you have work to do?";
			teaserLabel7.Font = textFont;
			teaserLabel7.Size = new Size( 300, 20 );
			teaserLabel7.Location = new Point( teaserLabel6.Left, teaserLabel6.Bottom + 500 );

			Label teaserLabel8 = new Label();
			teaserLabel8.Text = "Guess you're expecting something...";
			teaserLabel8.Font = textFont;
			teaserLabel8.Size = new Size( 300, 20 );
			teaserLabel8.Location = new Point( teaserLabel7.Left, teaserLabel7.Bottom + 400 );

			Label teaserLabel9 = new Label();
			teaserLabel9.Text = "Ok, here you go:";
			teaserLabel9.Font = textFont;
			teaserLabel9.Size = new Size( 300, 20 );
			teaserLabel9.Location = new Point( teaserLabel8.Left, teaserLabel8.Bottom + 300 );

			LinkLabel eggLabel = new LinkLabel();
			eggLabel.Text = "Meet The A-Team";
			eggLabel.Cursor = Cursors.Hand;
			eggLabel.Font = textFont;
			eggLabel.Size = new Size( 130, 20 );
			eggLabel.Location = new Point( teaserLabel9.Left, teaserLabel9.Bottom + 2 );
			eggLabel.LinkClicked += new LinkLabelLinkClickedEventHandler( linkClicked );

			creditsPanel.Size = new Size( maskPanel.Width - 2, eggLabel.Bottom + 10 );

			creditsPanel.Controls.AddRange( new Control[] { titleLabel, authorsLabel, garrettLabel, benLabel, jasonOLabel,
				jasonGLabel, daveLabel, thanksLabel, chuckLabel, chuckExpLabel, jimLabel, jimExpLabel, stephLabel,
				stephExpLabel, jLabel, jExpLabel, seLabel, seExpLabel, messageLabel, quotesLabel, quote1Label,
				quote2Label, quote3Label, quote4Label, quote5Label, quote6Label, quote7Label, quote8Label, quote9Label,
				quote10Label, quote11Label, quote12Label, teaserLabel1, teaserLabel2, teaserLabel3, teaserLabel4,
				teaserLabel5, teaserLabel6, teaserLabel7, teaserLabel8, teaserLabel9, eggLabel } );
		}

		/// <summary>
		/// Called after the form has been loaded and is being displayed.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void creditsFormLoaded( Object source, EventArgs e )
		{
			creditsPanel.Location = new Point( 0, maskPanel.Bottom );
			maskPanel.Controls.Add( creditsPanel );

			Thread rollThread = new Thread( new ThreadStart( rollCredits ) );
			rollThread.Start();
		}

		/// <summary>
		/// Rolls the credits.
		/// </summary>
		private void rollCredits()
		{
			while ( ( creditsPanel.Bottom != maskPanel.Top ) && !stop )
			{
				creditsPanel.Top -= 1;
				Thread.Sleep( 150 );
			}
		}

		/// <summary>
		/// Called when the ok button has been clicked.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void okButtonClicked( Object source, EventArgs e )
		{
			Close();
		}

		/// <summary>
		/// Called when the form is closing.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void formClosing( Object source, CancelEventArgs e )
		{
			stop = true;
		}

		/// <summary>
		/// Called when the link label is clicked.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void linkClicked( Object source, LinkLabelLinkClickedEventArgs e )
		{
			Form pictureForm = new Form();
			pictureForm.Text = "Meet the A-Team";
			pictureForm.StartPosition = FormStartPosition.CenterScreen;
			pictureForm.FormBorderStyle = FormBorderStyle.FixedDialog;
			pictureForm.MinimizeBox = false;
			pictureForm.MaximizeBox = false;
			pictureForm.ShowInTaskbar = false;
			pictureForm.Size = new Size( 1060, 657 );

			PictureBox imageBox = new PictureBox();
			Assembly jvmsAssembly = Assembly.GetExecutingAssembly();
			imageBox.Image = Image.FromStream( jvmsAssembly.GetManifestResourceStream( "jvms.resources.A-Team.jpg" ) );
			imageBox.Size = new Size( imageBox.Image.Width, imageBox.Image.Height );
			imageBox.Location = new Point( 0, 0 );

			Label captionLabel = new Label();
			captionLabel.Text = "From left to right: Jason Gilman, Ben Litchfield, Garrett Wampole, Jason Offord, David Bryant";
			captionLabel.Size = new Size( 1060, 20 );
			captionLabel.Location = new Point( 0, imageBox.Bottom + 5 );

			pictureForm.Controls.AddRange( new Control[] { imageBox, captionLabel } );
			pictureForm.ShowDialog( JVMSMain.JvmsForm );
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.maskPanel = new System.Windows.Forms.Panel();
			this.separator = new System.Windows.Forms.GroupBox();
			this.okButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// maskPanel
			// 
			this.maskPanel.BackColor = System.Drawing.Color.GhostWhite;
			this.maskPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.maskPanel.Location = new System.Drawing.Point(16, 16);
			this.maskPanel.Name = "maskPanel";
			this.maskPanel.Size = new System.Drawing.Size(336, 152);
			this.maskPanel.TabIndex = 0;
			// 
			// separator
			// 
			this.separator.Location = new System.Drawing.Point(8, 184);
			this.separator.Name = "separator";
			this.separator.Size = new System.Drawing.Size(352, 8);
			this.separator.TabIndex = 1;
			this.separator.TabStop = false;
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(296, 200);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(64, 23);
			this.okButton.TabIndex = 2;
			this.okButton.Text = "OK";
			// 
			// CreditsForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(370, 231);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.okButton,
																		  this.separator,
																		  this.maskPanel});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "CreditsForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Credits";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
