using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using jvms.datamodel.spd;
using jvms.presentation.drawablecomponent;

namespace jvms.presentation
{
	/// <summary>
	/// Summary description for NewDeviceConfigurationInstanceForm.
	/// </summary>
	public class NewDeviceConfigurationInstanceForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private NonSCAComponent selectedComponent = null;

		public NewDeviceConfigurationInstanceForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			foreach( Object control in ViewManager.Instance.PlatCompView.DrawableComponents )
			{
				if( control is BaseSCAComponentDrawableComponent ||
					control is NonSCAComponentDrawableComponent  )
				{
					comboBox1.Items.Add( ((DrawableComponent)control).getWrappedObject() );
				}
			}
			if( comboBox1.Items.Count > 0 )
			{
				comboBox1.SelectedIndex = 0;
			}
			this.cancelButton.Click += new EventHandler( cancelButtonClicked );
			this.okButton.Click += new EventHandler( okButtonClicked );
		}

		/// <summary>
		/// Called when the cancel button is clicked.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void cancelButtonClicked( Object source, EventArgs e )
		{
			this.Close();
		}

		/// <summary>
		/// Called when the ok button is clicked.
		/// </summary>
		/// <param name="source">A reference to the source of the event.</param>
		/// <param name="e">The event's data.</param>
		private void okButtonClicked( Object source, EventArgs e )
		{
			if( comboBox1.SelectedItem != null )
			{
				selectedComponent = (NonSCAComponent)comboBox1.SelectedItem;
				this.Close();
			}
			else
			{
				MessageBox.Show( "A component must be selected before adding an instance.", "Error" );
			}
		}

		/// <summary>
		/// This will get the component that was selected or null if none was selected.
		/// </summary>
		public NonSCAComponent SelectedComponent
		{
			get
			{
				return selectedComponent;
			}
			set
			{
				selectedComponent = value;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// comboBox1
			// 
			this.comboBox1.Location = new System.Drawing.Point(102, 16);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(121, 21);
			this.comboBox1.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(78, 14);
			this.label1.TabIndex = 1;
			this.label1.Text = "Instance Type";
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(84, 50);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 2;
			this.okButton.Text = "OK";
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(174, 50);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 3;
			this.cancelButton.Text = "Cancel";
			// 
			// NewDeviceConfigurationInstanceForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(260, 89);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cancelButton,
																		  this.okButton,
																		  this.label1,
																		  this.comboBox1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "NewDeviceConfigurationInstanceForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "New Instance";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
