using System;
using System.Collections;
using System.ComponentModel;

namespace jvms.presentation
{
	/// <summary>
	/// Summary description for PortXMLValueEditor.
	/// </summary>
	public class PortXMLValueEditor : ComplexXMLValueEditor
	{
		public PortXMLValueEditor()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		/// Edit's the specified object's value.
		/// </summary>
		/// <param name="context">Provides contextual information about the object.</param>
		/// <param name="provider">Can be used by the editor to obtain services.</param>
		/// <param name="value">The object to be edited.</param>
		/// <returns>The new value of the object.</returns>
		public override object EditValue( ITypeDescriptorContext context, IServiceProvider provider, Object value )
		{
			IList newValues = null;
			try
			{
				newValues = (IList)base.EditValue( context, provider, value );
				//basically remove all the from the old list and what is left must
				//have been deleted from the list.
				foreach( object obj in newValues )
				{
					originalList.Remove( obj );
				}
				RelationshipManager.Instance.removeRelationsWithPorts( originalList );
			}
			catch( Exception e )
			{
				Console.WriteLine( e );
			}
			return newValues;
		}
	}
}
