using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace jvms.presentation
{
	/// <summary>
	/// Summary description for StringArrayEditorForm.
	/// </summary>
	public class StringArrayEditorForm : System.Windows.Forms.Form
	{
		#region Windows Forms Designer generated state
		private System.Windows.Forms.Label editorLabel;
		private System.Windows.Forms.TextBox valuesTextBox;
		private System.Windows.Forms.GroupBox separator;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion
		
		private IList list = null;

		public StringArrayEditorForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Sets the list which is displayed in the editor.
		/// </summary>
		/// <param name="list">The desired list.</param>
		public void SetList( IList list )
		{
			this.list = list;
			//need to parse the list and display
			string[] lines = new string[list.Count + 1];
			for( int i = 0; i < list.Count; i++ )
			{
				lines[i] = (string)list[i];
			}
			lines[lines.Length-1] = ""; //add a blank line
			valuesTextBox.Lines = lines;

			//move cursor to the end
			int length = valuesTextBox.Text.Length;
			valuesTextBox.Select( length, length );
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.editorLabel = new System.Windows.Forms.Label();
			this.valuesTextBox = new System.Windows.Forms.TextBox();
			this.separator = new System.Windows.Forms.GroupBox();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// editorLabel
			// 
			this.editorLabel.Location = new System.Drawing.Point(8, 8);
			this.editorLabel.Name = "editorLabel";
			this.editorLabel.Size = new System.Drawing.Size(192, 16);
			this.editorLabel.TabIndex = 0;
			this.editorLabel.Text = "Please enter values, one on a line:";
			this.editorLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// valuesTextBox
			// 
			this.valuesTextBox.Location = new System.Drawing.Point(8, 32);
			this.valuesTextBox.Multiline = true;
			this.valuesTextBox.Name = "valuesTextBox";
			this.valuesTextBox.Size = new System.Drawing.Size(432, 216);
			this.valuesTextBox.TabIndex = 1;
			this.valuesTextBox.Text = "";
			// 
			// separator
			// 
			this.separator.Location = new System.Drawing.Point(8, 256);
			this.separator.Name = "separator";
			this.separator.Size = new System.Drawing.Size(432, 8);
			this.separator.TabIndex = 2;
			this.separator.TabStop = false;
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(280, 272);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(75, 24);
			this.okButton.TabIndex = 3;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(368, 272);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(75, 24);
			this.cancelButton.TabIndex = 4;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// StringArrayEditorForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(450, 303);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.okButton,
																		  this.cancelButton,
																		  this.separator,
																		  this.valuesTextBox,
																		  this.editorLabel});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "StringArrayEditorForm";
			this.ShowInTaskbar = false;
			this.Text = "Editor Dialog";
			this.ResumeLayout(false);

		}
		#endregion

		private void okButton_Click(object sender, System.EventArgs e)
		{
			//put items back in list
			list.Clear();
			foreach( string item in valuesTextBox.Lines )
			{
				//add lines that are not blank
				if( !"".Equals(item) )
				{
					list.Add( item );
				}
			}
			this.Close();
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			//just close the window
			this.Close();
		}

	}
}
