using System;
using System.Drawing;

namespace jvms.presentation
{
	/// <summary>
	/// Basically convets a point to a reference type (sigh).
	/// </summary>
	[Serializable]
	public class Vertex
	{
		private Point p;

		/// <summary>Sets or gets the point in this vertex.</summary>
		/// <value>A Point.</value>
		public Point Point
		{
			get
			{
				return p;
			}

			set
			{
				p = value;
			}
		}

		/// <summary>
		/// Creates a new Vertex.
		/// </summary>
		public Vertex()
		{
		}

		/// <summary>
		/// Creates a new Vertex with the given point.
		/// </summary>
		/// <param name="p">The desired point.</param>
		public Vertex( Point p )
		{
			this.p = p;
		}

		/// <summary>
		/// Returns a string representation of the object.
		/// </summary>
		/// <returns>A String.</returns>
		public override String ToString()
		{
			return p.ToString();
		}
	}
}
