using System;

using jvms.presentation;
using jvms.presentation.drawablecomponent;

namespace jvms.validation
{
	/// <summary>
	/// Summary description for RuleResult.
	/// </summary>
	public class RuleResult
	{
		private View view;
		private DrawableComponent component;
		private String errorMessage;

		public RuleResult()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		/// The view that the drawable component resides on.
		/// </summary>
		public View View
		{
			get{ return view; }
			set{ view = value; }
		}

		/// <summary>
		/// The drawable component that the error relates to.
		/// </summary>
		public DrawableComponent Component
		{
			get{ return component; }
			set{ component = value; }
		}

		/// <summary>
		/// The error message from the rule.
		/// </summary>
		public String ErrorMessage
		{
			get{ return errorMessage; }
			set{ errorMessage = value; }
		}

		public override String ToString()
		{
			return "view=" + view.Tag + " component=" + component + " error=" + errorMessage;
		}
	}
}
