using System;
using System.Collections;
using System.Reflection;

namespace jvms.ruleframework
{
	/// <summary>
	/// The rule manager is maintaining all validation rules available in the system.
	/// </summary>
	public class RuleManager
	{
		/// <summary>
		/// Creates a new RuleManager.
		/// </summary>
		public RuleManager()
		{
		}

		public IList getRules()
		{
			IList rules = new ArrayList();
			Assembly jvmsAssembly = Assembly.GetExecutingAssembly();
			String assemblyDir = assemblyDir = jvmsAssembly.Location.Substring( 0, jvmsAssembly.Location.LastIndexOf( '\\' ) + 1 );
			Assembly assembly = Assembly.LoadFrom( assemblyDir + "Rules.dll" );
			foreach( Type type in assembly.GetTypes() )
			{
				if( typeof( Rule ).IsAssignableFrom( type ) )
				{
					ConstructorInfo ctor = type.GetConstructor( new Type[] {} );
					Object rule = ctor.Invoke( new Object[] {} );
					rules.Add( rule );
				}
			}
			return rules;
		}
	}
}
